using System;
using System.Windows.Forms;
using System.Drawing;
using System.ComponentModel;

namespace TYWinForms.Day3 {

   public class Exercise1 : Form {
      private Label lblMessage = new Label();

      public Exercise1() {
         lblMessage.Width = this.Width;
         lblMessage.Height = this.Height;

         this.Text = "Mouse events Example";
         this.Width = 800;
         this.Height = 600;
         this.MouseEnter += new EventHandler(this.MouseEntered);
         this.MouseHover += new EventHandler(this.MouseHovered);
         this.MouseLeave += new EventHandler(this.MouseLeft);
         this.MouseMove += new MouseEventHandler(this.MouseMoved);
         this.MouseDown += new MouseEventHandler(this.MouseClicked);
         this.MouseUp += new MouseEventHandler(this.MouseReleased);

         this.Controls.Add(lblMessage);
      }
   
      public void MouseEntered(Object Sender, EventArgs e) {
         lblMessage.Text += "Mouse entered\r\n";
      }

      public void MouseHovered(Object Sender, EventArgs e) {
         lblMessage.Text += "Mouse hovered\r\n";
      }

      public void MouseLeft(Object Sender, EventArgs e) {
         lblMessage.Text += "Mouse left\r\n";
      }

      public void MouseMoved(Object Sender, MouseEventArgs e) {
         lblMessage.Text += "Mouse moved: x=" + e.X + ", y=" + e.Y + "\r\n";
      }

      public void MouseClicked(Object Sender, MouseEventArgs e) {
         lblMessage.Text += "Button clicked: " + e.Button + "\r\n";
      }

      public void MouseReleased(Object Sender, MouseEventArgs e) {
         lblMessage.Text += "Button released: x=" + e.X + ", y=" + e.Y + "\r\n";
      }

      public static void Main() {
         Application.Run(new Exercise1());
      }
   }
}