using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinForms.Day4 {

   public class Listing410 : Form {
      Label lblMessage = new Label();
      VScrollBar vbarForm = new VScrollBar();
      HScrollBar hbarForm = new HScrollBar();

      public Listing410() {
         lblMessage.Location = new Point(75,75);
         lblMessage.Width = 200;

         vbarForm.Dock = DockStyle.Right;
         vbarForm.Visible = true;
         vbarForm.Scroll += new ScrollEventHandler(this.HandleScroll);
         hbarForm.Dock = DockStyle.Bottom;
         hbarForm.Visible = true;
         hbarForm.Scroll += new ScrollEventHandler(this.HandleScroll);

         this.Text = "ScrollEventType Value Example";
         this.Height = 200;
         this.Controls.Add(lblMessage);
         this.Controls.Add(vbarForm);
         this.Controls.Add(hbarForm);
      }
   
      public void HandleScroll(Object Sender, ScrollEventArgs e) {
         switch(e.Type) {
            case ScrollEventType.EndScroll:
               lblMessage.Text = "Scroll box has stopped moving";
               break;
            case ScrollEventType.First:
               lblMessage.Text = "Scroll box is at " + ((ScrollBar)Sender).Minimum.ToString();
               break;
            case ScrollEventType.LargeDecrement:
               lblMessage.Text = "Scroll box has moved -" + ((ScrollBar)Sender).LargeChange.ToString();
               break;
            case ScrollEventType.LargeIncrement:
               lblMessage.Text = "Scroll box has moved " + ((ScrollBar)Sender).LargeChange.ToString();
               break;
            case ScrollEventType.Last:
               lblMessage.Text = "Scroll box is at " + ((ScrollBar)Sender).Maximum.ToString();
               break;
            case ScrollEventType.SmallDecrement:
               lblMessage.Text = "Scroll box has moved -" + ((ScrollBar)Sender).SmallChange.ToString();
               break;
            case ScrollEventType.SmallIncrement:
               lblMessage.Text = "Scroll box has moved " + ((ScrollBar)Sender).SmallChange.ToString();
               break;
            case ScrollEventType.ThumbPosition:
               lblMessage.Text = "Scroll box was moved";
               break;
            case ScrollEventType.ThumbTrack:
               lblMessage.Text = "Scroll box is moving";
               break;
         }
      lblMessage.Text += ((ScrollBar)Sender).Value.ToString() + ":" + e.NewValue.ToString();
      }
   }

   public class StartForm {
      public static void Main() {
         Application.Run(new Listing410());
      }
   }
}