using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinforms.Day5 {

   public class Calculator : Form {
      private TextBox tbNumber = new TextBox();
      private TextBox tbHiddenNumber = new TextBox();
      private TextBox tbHiddenOperator = new TextBox();
      private TextBox tbHiddenAnswer = new TextBox();

      private Button btZero = new Button();
      private Button btOne = new Button();
      private Button btTwo = new Button();
      private Button btThree = new Button();
      private Button btFour = new Button();
      private Button btFive = new Button();
      private Button btSix = new Button();
      private Button btSeven = new Button();
      private Button btEight = new Button();
      private Button btNine = new Button();

      private Button btAdd = new Button();
      private Button btSubtract = new Button();
      private Button btMultiply = new Button();
      private Button btDivide = new Button();
      private Button btEquals = new Button();

      public Calculator() {
         tbNumber.Location = new Point(210,10);
         tbNumber.Width = 100;

         tbHiddenNumber.Visible = false;
         tbHiddenOperator.Visible = false;
         tbHiddenAnswer.Visible = false;
 
         btZero.Text = "0";
         btZero.Location = new Point(10,125);
         btZero.Click += new EventHandler(this.NumberClick);

         btOne.Text = "1";
         btOne.Location = new Point(10,100);
         btOne.Click += new EventHandler(this.NumberClick);

         btTwo.Text = "2";
         btTwo.Location = new Point(85,100);
         btTwo.Click += new EventHandler(this.NumberClick);

         btThree.Text = "3";
         btThree.Location = new Point(160,100);
         btThree.Click += new EventHandler(this.NumberClick);

         btFour.Text = "4";
         btFour.Location = new Point(10,75);
         btFour.Click += new EventHandler(this.NumberClick);

         btFive.Text = "5";
         btFive.Location = new Point(85,75);
         btFive.Click += new EventHandler(this.NumberClick);

         btSix.Text = "6";
         btSix.Location = new Point(160,75);
         btSix.Click += new EventHandler(this.NumberClick);

         btSeven.Text = "7";
         btSeven.Location = new Point(10,50);
         btSeven.Click += new EventHandler(this.NumberClick);

         btEight.Text = "8";
         btEight.Location = new Point(85,50);
         btEight.Click += new EventHandler(this.NumberClick);

         btNine.Text = "9";
         btNine.Location = new Point(160,50);
         btNine.Click += new EventHandler(this.NumberClick);

         btAdd.Text = "+";
         btAdd.Location = new Point(160,125);
         btAdd.Click += new EventHandler(this.OperatorClick);

         btSubtract.Text = "-";
         btSubtract.Location = new Point(235,100);
         btSubtract.Click += new EventHandler(this.OperatorClick);

         btMultiply.Text = "*";
         btMultiply.Location = new Point(235,75);
         btMultiply.Click += new EventHandler(this.OperatorClick);

         btDivide.Text = "/";
         btDivide.Location = new Point(235,50);
         btDivide.Click += new EventHandler(this.OperatorClick);

         btEquals.Text = "=";
         btEquals.Location = new Point(235,125);
         btEquals.Click += new EventHandler(this.OperatorClick);


         this.Text = "Calculator";
         this.Width = 325;
         this.Height = 200;
         this.Controls.Add(btZero);
         this.Controls.Add(btOne);
         this.Controls.Add(btTwo);
         this.Controls.Add(btThree);
         this.Controls.Add(btFour);
         this.Controls.Add(btFive);
         this.Controls.Add(btSix);
         this.Controls.Add(btSeven);
         this.Controls.Add(btEight);
         this.Controls.Add(btNine);
         this.Controls.Add(btAdd);
         this.Controls.Add(btSubtract);
         this.Controls.Add(btMultiply);
         this.Controls.Add(btDivide);
         this.Controls.Add(btEquals);
         this.Controls.Add(tbNumber);
         this.Controls.Add(tbHiddenOperator);
         this.Controls.Add(tbHiddenNumber);
         this.Controls.Add(tbHiddenAnswer);
      }

      public void NumberClick(Object Sender, EventArgs e) {
         if (tbNumber.Text != "" & tbNumber.Text != "0" & tbHiddenAnswer.Text != "1") {
            tbNumber.Text += ((Button)Sender).Text;
         } else {
            tbNumber.Text = ((Button)Sender).Text;
            tbHiddenAnswer.Text = "";
         }
      }

      public void OperatorClick(Object Sender, EventArgs e) {
         int intAnswer = 0;

         if (tbNumber.Text != "" & ((Button)Sender).Text != "=") {
            tbHiddenNumber.Text = tbNumber.Text;
            tbHiddenOperator.Text = ((Button)Sender).Text;
            tbNumber.Text = "0";            
         } else if (tbNumber.Text != "" & ((Button)Sender).Text == "=") {
            switch(tbHiddenOperator.Text) {
               case "+":
                  intAnswer = Convert.ToInt32(tbHiddenNumber.Text) + Convert.ToInt32(tbNumber.Text);
                  break;
               case "-":
                  intAnswer = Convert.ToInt32(tbHiddenNumber.Text) - Convert.ToInt32(tbNumber.Text);
                  break;
               case "*":
                  intAnswer = Convert.ToInt32(tbHiddenNumber.Text) * Convert.ToInt32(tbNumber.Text);
                  break;
               case "/":
                  intAnswer = Convert.ToInt32(tbHiddenNumber.Text) / Convert.ToInt32(tbNumber.Text);
                  break;
            }
            tbNumber.Text = intAnswer.ToString();
            tbHiddenAnswer.Text = "1";
            tbHiddenNumber.Text = "";
            tbHiddenOperator.Text = "";
         }
      }

      public static void Main() {
         Application.Run(new Calculator());
      }
   }
}