using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinforms.Day5 {
   public class GolfBall {
      public event EventHandler Sunk;

      protected virtual void OnSunk(EventArgs e) {
         if (Sunk != null) {
            Sunk(this, e);
         }
      }

      public void Putt(int intStrength) {
         if (intStrength == 5) {
            OnSunk(new EventArgs());
         }
      }
   }

   public class MainForm : Form {
      private Button btPutt = new Button();
      private Label lblStrength = new Label();
      private TextBox tbStrength = new TextBox();
      private GolfBall gfBall = new GolfBall();

      public MainForm() {
         lblStrength.Text = "Strength:";
         lblStrength.Location = new Point(50,50);

         tbStrength.Text = 0.ToString();
         tbStrength.Location = new Point(125, 50);

         btPutt.Text = "Putt the ball";
         btPutt.Location = new Point(100, 100);
         btPutt.Click += new EventHandler(this.PuttBall);

         gfBall.Sunk += new EventHandler(this.BallSunk);

         this.Text = "Custom event example";
         this.Controls.Add(btPutt);
         this.Controls.Add(tbStrength);
         this.Controls.Add(lblStrength);
      }

      public void PuttBall(Object Sender, EventArgs e) {
         gfBall.Putt(Convert.ToInt32(tbStrength.Text));
      }

      public void BallSunk(Object Sender, EventArgs e) {
         MessageBox.Show("Sunk!");
      }

      public static void Main() {
         Application.Run(new MainForm());
      }
   }
}