using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinforms.Day5 {
   public class GolfBallEventArgs : EventArgs {
      public readonly int Feet;
      public readonly bool Save;

      public GolfBallEventArgs(int Feet, bool Save) {
         this.Feet = Feet;
         this.Save = Save;
      }
   }

   public delegate void GolfBallEventHandler(Object Sender, GolfBallEventArgs e);

   public class GolfBall {
      public event GolfBallEventHandler Sunk;

      protected virtual void OnSunk(GolfBallEventArgs e) {
         if (Sunk != null) {
            Sunk(this, e);
         }
      }

      public void Putt(int intStrength) {
         if (intStrength == 5) {
            Random rndGen = new Random();
            OnSunk(new GolfBallEventArgs(rndGen.Next(1,101), Convert.ToBoolean(rndGen.Next(0,2))));
         }
      }
   }

   public class MainForm : Form {
      private Button btPutt = new Button();
      private Label lblStrength = new Label();
      private TextBox tbStrength = new TextBox();
      private GolfBall gfBall = new GolfBall();

      public MainForm() {
         lblStrength.Text = "Strength:";
         lblStrength.Location = new Point(50,50);

         tbStrength.Text = 0.ToString();
         tbStrength.Location = new Point(125, 50);

         btPutt.Text = "Putt the ball";
         btPutt.Location = new Point(100, 100);
         btPutt.Click += new EventHandler(this.PuttBall);

         gfBall.Sunk += new GolfBallEventHandler(this.BallSunk);

         this.Text = "Custom event example";
         this.Controls.Add(btPutt);
         this.Controls.Add(tbStrength);
         this.Controls.Add(lblStrength);
      }

      public void PuttBall(Object Sender, EventArgs e) {
         gfBall.Putt(Convert.ToInt16(tbStrength.Text));
      }

      public void BallSunk(Object Sender, GolfBallEventArgs e) {
         MessageBox.Show("Sunk from " + e.Feet.ToString() + " feet!");
      }

      public static void Main() {
         Application.Run(new MainForm());
      }
   }
}