using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinForms.Day6 {

   public class CDCatalog : Form {
      private TreeView tvList = new TreeView();
      private TextBox tbName = new TextBox();
      private Button btArtist = new Button();
      private Button btAlbum = new Button();
      private Button btSong = new Button();

      public CDCatalog() {
         tvList.Location = new Point(10,10);
         tvList.Size = new Size(200,550);
         tvList.LabelEdit = true;

         tbName.Location = new Point(250,10);
         tbName.Width = 150;

         btArtist.Location = new Point(225,40);
         btArtist.Text = "Add Artist";
         btArtist.Click += new EventHandler(this.AddArtist);

         btAlbum.Location = new Point(300,40);
         btAlbum.Text = "Add Album";
         btAlbum.Click += new EventHandler(this.AddAlbum);

         btSong.Location = new Point(375,40);
         btSong.Text = "Add Song";
         btSong.Click += new EventHandler(this.AddSong);

         this.Text = "CD Catalog";
         this.Size = new Size(800,600);
         this.Controls.Add(tvList);
         this.Controls.Add(tbName);
         this.Controls.Add(btArtist);
         this.Controls.Add(btAlbum);
         this.Controls.Add(btSong);
      }

      public void AddArtist(Object Sender, EventArgs e) {
         if (tbName.Text == "") {
            MessageBox.Show("You forgot to enter a name");
            return;
         }

         tvList.Nodes.Add(new TreeNode(tbName.Text));
         tbName.Text = "";
      }

      public void AddAlbum(Object Sender, EventArgs e) {
         if (tbName.Text == "") {
            MessageBox.Show("You forgot to enter a name");
            return;
         }

         if (tvList.SelectedNode != null & tvList.Nodes.Contains(tvList.SelectedNode)) {
            tvList.SelectedNode.Nodes.Add(new TreeNode(tbName.Text));
            tbName.Text = "";
            tvList.ExpandAll();
         } else {
            MessageBox.Show("You must first select an artist");
         }
      }

      public void AddSong(Object Sender, EventArgs e) {
         if (tbName.Text == "") {
            MessageBox.Show("You forgot to enter a name");
            return;
         }

         if (tvList.SelectedNode != null & tvList.Nodes.Contains(tvList.SelectedNode.Parent)) {
            tvList.SelectedNode.Nodes.Add(new TreeNode(tbName.Text));
            tbName.Text = "";
            tvList.ExpandAll();
         } else {
            MessageBox.Show("You must first select an album");
         }
      }

      public static void Main() {
         Application.Run(new CDCatalog());
      }
   }
}