Imports System
Imports System.Windows.Forms
Imports System.Drawing

Namespace TYWinForms.Day6

   Public Class Listing613 : Inherits Form
      Private WithEvents pnlButton As New Panel
      Private WithEvents pnlControls As New Panel
      Private WithEvents gboxAnchor As New GroupBox
      Private WithEvents gboxDock As New GroupBox
      Private WithEvents btnDemo As New Button
      Private WithEvents rbNone As New RadioButton
      Private WithEvents rbTop As New RadioButton
      Private WithEvents rbLeft As New RadioButton
      Private WithEvents rbBottom As New RadioButton
      Private WithEvents rbRight As New RadioButton
      Private WithEvents rbFill As New RadioButton
      Private WithEvents chkTop As New CheckBox
      Private WithEvents chkLeft As New CheckBox
      Private WithEvents chkBottom As New CheckBox
      Private WithEvents chkRight As New CheckBox

      Public Sub New()
         rbRight.Location = New Point(8,120)
         rbRight.Size = New Size(72,24)
         rbRight.Text = "Right"

         rbNone.Location = New Point(8,24)
         rbNone.Size = New Size(72,24)
         rbNone.Text = "None"
         rbNone.Checked = True

         rbBottom.Location = New Point(8,96)
         rbBottom.Size = New Size(72,24)
         rbBottom.Text = "Bottom"

         rbTop.Location = New Point(8,48)
         rbTop.Size = New Size(72,24)
         rbTop.Text = "Top"

         rbLeft.Location = New Point(8,72)
         rbLeft.Size = New Size(72,24)
         rbLeft.Text = "Left"

         rbFill.Location = New Point(8,144)
         rbFill.Size = New Size(72,24)
         rbFill.Text = "Fill"

         gboxAnchor.Location = New Point(16,16)
         gboxAnchor.Size = New Size(88,128)
         gboxAnchor.Text = "Anchor"

         gboxDock.Location = New Point(16,152)
         gboxDock.Size = New Size(88,176)
         gboxDock.Text = "Dock"

         btnDemo.Size = New Size(120,24)
         btnDemo.Anchor = AnchorStyles.None
         btnDemo.Location = New Point(64,72)
         btnDemo.Text = "Play with Me!"

         chkBottom.Location = New Point(8,72)
         chkBottom.Size = New Size(72,24)
         chkBottom.Text = "Bottom"

         chkLeft.Location = New Point(8,48)
         chkLeft.Size = New Size(72,24)
         chkLeft.Text = "Left"

         chkTop.Location = New Point(8,24)
         chkTop.Size = New Size(72,24)
         chkTop.Text = "Top"

         chkRight.Location = New Point(8,96)
         chkRight.Size = New Size(72,24)
         chkRight.Text = "Right"

         pnlButton.BorderStyle = FormBorderStyle.Fixed3D
         pnlButton.Dock = DockStyle.Fill
         pnlButton.Size = New Size(448,400)
         pnlButton.Text = "ButtonPanel"
         pnlButton.Controls.Add(btnDemo)

         pnlControls.BorderStyle = FormBorderStyle.Fixed3D
         pnlControls.Dock = DockStyle.Right
         pnlControls.Location = New Point(328,0)
         pnlControls.Size = New Size(120,400)
         pnlControls.Text = "ControlsPanel"
         pnlControls.Controls.Add(gboxAnchor)
         pnlControls.Controls.Add(gboxDock)

         gboxAnchor.Controls.Add(chkRight)
         gboxAnchor.Controls.Add(chkBottom)
         gboxAnchor.Controls.Add(chkLeft)
         gboxAnchor.Controls.Add(chkTop)
         gboxDock.Controls.Add(rbBottom)
         gboxDock.Controls.Add(rbLeft)
         gboxDock.Controls.Add(rbNone)
         gboxDock.Controls.Add(rbRight)
         gboxDock.Controls.Add(rbFill)
         gboxDock.Controls.Add(rbTop)

         Me.Text = "Listing 6.13"
         Me.Size = New Size(800,600)
         Me.Controls.Add(pnlButton)
         Me.Controls.Add(pnlControls)
      End Sub

      Private Sub AnchorClicked(Sender As Object,e As EventArgs) Handles chkBottom.Click,chkLeft.Click,chkRight.Click,chkTop.Click
         If chkTop.Checked Then
            btnDemo.Anchor = btnDemo.Anchor Or AnchorStyles.Top
         End If

         If chkLeft.Checked Then
            btnDemo.Anchor = btnDemo.Anchor Or AnchorStyles.Left
         End If

         If chkBottom.Checked Then
            btnDemo.Anchor = btnDemo.Anchor Or AnchorStyles.Bottom
         End If

         If chkRight.Checked Then
            btnDemo.Anchor = btnDemo.Anchor Or AnchorStyles.Right
         End If
      End Sub

      Private Sub DockClicked(Sender As Object,e As EventArgs) Handles rbBottom.Click,rbFill.Click,rbLeft.Click,rbRight.Click,rbTop.Click,rbNone.Click
         dim rbSet as RadioButton = CType(sender,RadioButton)

         If rbSet Is rbNone Then
            btnDemo.Dock = DockStyle.None
         ElseIf rbSet Is rbTop Then
            btnDemo.Dock = DockStyle.Top
         ElseIf rbSet Is rbLeft Then
            btnDemo.Dock = DockStyle.Left
         ElseIf rbSet Is rbBottom Then
            btnDemo.Dock = DockStyle.Bottom
         ElseIf rbSet Is rbRight Then
            btnDemo.Dock = DockStyle.Right
         Else
            btnDemo.Dock = DockStyle.Fill
         End If
      End Sub

      public shared sub Main()
         Application.Run(New Listing613)
      end sub
   End Class
End Namespace