Imports System
Imports System.Windows.Forms
Imports System.Drawing

Namespace TYWinForms.Day6

   Public Class Listing69 : Inherits Form 
      private rtbText as New RichTextBox
      private intFontSize as Integer
      private strFontColor as String
      private strFontStyle as String

      private cmnuText as New ContextMenu
      private cmniFont as New MenuItem
      private cmniBold as New MenuItem
      private cmniItalics as New MenuItem
      private cmniNormal as New MenuItem
      private cmniFontSize as New MenuItem
      private cmniSize8 as New MenuItem
      private cmniSize10 as New MenuItem
      private cmniSize12 as New MenuItem
      private cmniSize14 as New MenuItem
      private cmniColor as New MenuItem
      private cmniColorRed as New MenuItem
      private cmniColorBlue as New MenuItem
      private cmniColorGreen as New MenuItem
      private cmniColorBlack as New MenuItem

      public sub New()
         intFontSize = 10
         strFontColor = "Black"
         strFontStyle = "Normal"

         rtbText.Dock = DockStyle.Fill
         rtbText.ScrollBars = RichTextBoxScrollBars.Both
         rtbText.ContextMenu = cmnuText

         cmnuText.MenuItems.Add(cmniFont)
         cmnuText.MenuItems.Add(cmniFontSize)
         cmnuText.MenuItems.Add(cmniColor)

         cmniFont.Text = "Font"
         cmniBold.Text = "Bold"
         cmniFont.MenuItems.Add(cmniBold)
         cmniItalics.Text = "Italics"
         cmniFont.MenuItems.Add(cmniItalics)
         cmniNormal.Text = "Normal"
         cmniNormal.Checked = true
         cmniFont.MenuItems.Add(cmniNormal)
         AddHandler cmniBold.Click, new EventHandler(AddressOf Me.HandleFont)
         AddHandler cmniItalics.Click, new EventHandler(AddressOf Me.HandleFont)
         AddHandler cmniNormal.Click, new EventHandler(AddressOf Me.HandleFont)

         cmniFontSize.Text = "Size"
         cmniSize8.Text = "8"
         cmniFontSize.MenuItems.Add(cmniSize8)
         cmniSize10.Text = "10"
         cmniSize10.Checked = true
         cmniFontSize.MenuItems.Add(cmniSize10)
         cmniSize12.Text = "12"
         cmniFontSize.MenuItems.Add(cmniSize12)
         cmniSize14.Text = "14"
         cmniFontSize.MenuItems.Add(cmniSize14)
         AddHandler cmniSize8.Click, new EventHandler(AddressOf Me.HandleFontSize)
         AddHandler cmniSize10.Click, new EventHandler(AddressOf Me.HandleFontSize)
         AddHandler cmniSize12.Click, new EventHandler(AddressOf Me.HandleFontSize)
         AddHandler cmniSize14.Click, new EventHandler(AddressOf Me.HandleFontSize)

         cmniColor.Text = "Color"
         cmniColorRed.Text = "Red"
         cmniColor.MenuItems.Add(cmniColorRed)
         cmniColorBlue.Text = "Blue"
         cmniColor.MenuItems.Add(cmniColorBlue)
         cmniColorGreen.Text = "Green"
         cmniColor.MenuItems.Add(cmniColorGreen)
         cmniColorBlack.Text = "Black"
         cmniColorBlack.Checked = true
         cmniColor.MenuItems.Add(cmniColorBlack)
         AddHandler cmniColorRed.Click, new EventHandler(AddressOf Me.HandleFontColor)
         AddHandler cmniColorBlue.Click, new EventHandler(AddressOf Me.HandleFontColor)
         AddHandler cmniColorGreen.Click, new EventHandler(AddressOf Me.HandleFontColor)
         AddHandler cmniColorBlack.Click, new EventHandler(AddressOf Me.HandleFontColor)

         Me.Text = "Listing 6.9"
         Me.Font = New Font("Times New Roman", intFontSize)
         Me.Controls.Add(rtbText)
      end sub

      public sub HandleFont(Sender as Object, e as EventArgs)
         strFontStyle = CType(Sender, MenuItem).Text
         rtbText.SelectionFont = new Font("Times New Roman", intFontSize, ConvertToFontStyle(strFontStyle))

         cmniBold.Checked = false
         cmniItalics.Checked = false
         cmniNormal.Checked = false

         CType(Sender, MenuItem).Checked = true
      end sub

      public sub HandleFontSize(Sender as Object, e as EventArgs)
         intFontSize = Convert.ToInt32(CType(Sender, MenuItem).Text)
         rtbText.SelectionFont = new Font("Times New Roman", intFontSize, ConvertToFontStyle(strFontStyle))

         cmniSize8.Checked = false
         cmniSize10.Checked = false
         cmniSize12.Checked = false
         cmniSize14.Checked = false

         CType(Sender, MenuItem).Checked = true
      end sub

      public sub HandleFontColor(Sender as Object, e as EventArgs)
         strFontColor = CType(Sender, MenuItem).Text
         rtbText.SelectionColor = Color.FromName(strFontColor)

         cmniColorRed.Checked = false
         cmniColorBlue.Checked = false
         cmniColorGreen.Checked = false
         cmniColorBlack.Checked = false

         CType(Sender, MenuItem).Checked = true
      end sub

      private function ConvertToFontStyle(strStyle) as FontStyle
         select strStyle
            case "Bold" 
               return FontStyle.Bold
            case "Italics" 
               return FontStyle.Italic
            case "Normal" 
               return  FontStyle.Regular
         end select
      end function

      public shared sub Main() 
         Application.Run(new Listing69)
      end sub
   End Class
End Namespace