using System;
using System.Windows.Forms;
using System.Drawing;
using System.Data;

namespace TYWinforms.Day8 {
   public class Exercise1 : Form {
      private DataGrid dgMoney = new DataGrid();
      private DataTable dtMoney = new DataTable("Money");

      private Panel pnlAdd = new Panel();
      private TextBox tbNum = new TextBox();
      private TextBox tbDate = new TextBox();
      private TextBox tbPayee = new TextBox();
      private TextBox tbAmount = new TextBox();
      private Label lblNum = new Label();
      private Label lblDate = new Label();
      private Label lblPayee = new Label();
      private Label lblAmount = new Label();
      private Button btSubmit = new Button();

      public Exercise1() {
         //create columns
         DataColumn colNum = new DataColumn();
         colNum.DataType = System.Type.GetType("System.Int32");
         colNum.ColumnName = "Check Number";
         dtMoney.Columns.Add(colNum);

         DataColumn colAmount = new DataColumn();
         colAmount.DataType = System.Type.GetType("System.Double");
         colAmount.ColumnName = "Amount";
         dtMoney.Columns.Add(colAmount);

         DataColumn colPayee = new DataColumn();
         colPayee.DataType = System.Type.GetType("System.String");
         colPayee.ColumnName = "Payee";
         dtMoney.Columns.Add(colPayee);

         DataColumn colDate = new DataColumn();
         colDate.DataType = System.Type.GetType("System.DateTime");
         colDate.ColumnName = "Date";
         dtMoney.Columns.Add(colDate);

         //create styles
         DataGridTableStyle dgtStyle = new DataGridTableStyle();
         dgtStyle.MappingName = "Money";
         
         DataGridTextBoxColumn dgcStyle = new DataGridTextBoxColumn();
         dgcStyle.MappingName = "Check Number";
         dgcStyle.ReadOnly = true;         
         dgcStyle.HeaderText = "Check No.";
         dgcStyle.Width = 100;
         dgtStyle.GridColumnStyles.Add(dgcStyle);
         
         dgcStyle = new DataGridTextBoxColumn();
         dgcStyle.MappingName = "Date";
         dgcStyle.ReadOnly = true;         
         dgcStyle.HeaderText = "Date";
         dgcStyle.Width = 100;
         dgtStyle.GridColumnStyles.Add(dgcStyle);

         dgcStyle = new DataGridTextBoxColumn();
         dgcStyle.MappingName = "Payee";
         dgcStyle.ReadOnly = true;         
         dgcStyle.HeaderText = "Payee";
         dgcStyle.Width = 452;
         dgtStyle.GridColumnStyles.Add(dgcStyle);

         dgcStyle = new DataGridTextBoxColumn();
         dgcStyle.MappingName = "Amount";
         dgcStyle.ReadOnly = true;         
         dgcStyle.HeaderText = "Amount";
         dgcStyle.Width = 100;
         dgcStyle.Format = "c";
         dgtStyle.GridColumnStyles.Add(dgcStyle);

         //create add form
         lblNum.Text = "Check No.";
         lblNum.Location = new Point(10,250);
         tbNum.Location = new Point(75,245);

         lblDate.Text = "Date";
         lblDate.Location = new Point(600,250);
         tbDate.Location = new Point(675,245);

         lblPayee.Text = "Pay To:";
         lblPayee.Location = new Point(10,280);
         tbPayee.Location = new Point(75,275);
         tbPayee.Width = 400;

         lblAmount.Text = "Amount";
         lblAmount.Location = new Point(600,280);
         tbAmount.Location = new Point(675,275);

         btSubmit.Text = "Enter";
         btSubmit.Location = new Point(675,310);
         btSubmit.Click += new EventHandler(this.AddRecord);

         pnlAdd.Size = new Size(800,500);
         pnlAdd.Dock = DockStyle.Bottom;
         pnlAdd.BackColor = Color.Tan;
         pnlAdd.Controls.Add(tbNum);
         pnlAdd.Controls.Add(tbDate);
         pnlAdd.Controls.Add(tbPayee);
         pnlAdd.Controls.Add(tbAmount);
         pnlAdd.Controls.Add(lblNum);
         pnlAdd.Controls.Add(lblDate);
         pnlAdd.Controls.Add(lblPayee);
         pnlAdd.Controls.Add(lblAmount);
         pnlAdd.Controls.Add(btSubmit);

         dgMoney.Dock = DockStyle.Top;
         dgMoney.Size = new Size(800,300);
         dgMoney.CaptionText = "Checkbook Register";
         dgMoney.BackgroundColor = Color.White;
         dgMoney.TableStyles.Add(dgtStyle);
         dgMoney.DataSource = dtMoney;

         this.Size = new Size(800,600);
         this.Text = ".NET Check Book Register";
         this.Controls.Add(dgMoney);
         this.Controls.Add(pnlAdd);         
      }

      private void AddRecord(Object Sender, EventArgs e) {
         if (tbPayee.Text == "" | tbAmount.Text == "") {
            MessageBox.Show("You forgot to enter a payee or amount.","Check Register");
         } else {
            DataRow newRow = dtMoney.NewRow();

            newRow[0] = Convert.ToInt32(tbNum.Text);
            newRow[1] = Convert.ToDouble(tbAmount.Text);
            newRow[2] = tbPayee.Text;
            newRow[3] = Convert.ToDateTime(tbDate.Text);

            dtMoney.Rows.Add(newRow);

            tbNum.Text = "";
            tbDate.Text = "";
            tbAmount.Text = "";
            tbPayee.Text = "";
         }
      }

      public static void Main() {
         Application.Run(new Exercise1());
      }
   }
}