using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinforms.Day8 {
   public class Listing82 : Form {
      private ComboBox cboData = new ComboBox();
      private Button btChange = new Button();
      private Color[] arrColors = {Color.Green, Color.Blue, Color.Red, Color.Orange};
      private int intLastIndex;

      public Listing82() {
         cboData.Location = new Point(50,75);
         cboData.DropDownStyle = ComboBoxStyle.Simple;
         cboData.DataBindings.Add("BackColor", arrColors, "");
         cboData.DataSource = arrColors;
         cboData.SelectedIndexChanged += new EventHandler(this.ChangeColor);

         btChange.Location = new Point(175,75);
         btChange.Text = "Change";
         btChange.Click += new EventHandler(this.EditColor);

         this.Controls.Add(cboData);
         this.Controls.Add(btChange);
      }

      public void ChangeColor(Object Sender, EventArgs e) {
         cboData.BindingContext[arrColors].Position = cboData.SelectedIndex;
         intLastIndex = cboData.SelectedIndex;
      }

      public void EditColor(Object Sender, EventArgs e) {
         arrColors[intLastIndex] = Color.FromName(cboData.Text);
         cboData.SelectedText = Color.FromName(cboData.Text).ToString();
         cboData.SelectedIndex = intLastIndex;
      }

      public static void Main() {
         Application.Run(new Listing82());
      }
   }
}