using System;
using System.Windows.Forms;
using System.Drawing;
using System.Data;
using System.Data.SqlClient;

namespace TYWinforms.Day9 {
   public class Listing92 : Form {
      DataSet objDS = new DataSet("tblUsers");
      SqlDataAdapter objCmd;

      TextBox tbFirstName = new TextBox();
      TextBox tbLastName = new TextBox();
      Label lblFirstName = new Label();
      Label lblLastName = new Label();
      Button btNext = new Button();
      Button btPrev = new Button();
      Button btSave = new Button();

      public Listing92() {
         lblFirstName.Location = new Point(10,10);
         lblFirstName.Text = "First Name:";
         lblLastName.Location = new Point(10,35);
         lblLastName.Text = "Last Name:";
         tbFirstName.Location = new Point(75,10);
         tbLastName.Location = new Point(75,30);

         btNext.Text = "Next";
         btNext.Location = new Point(150,75);
         btNext.Click += new EventHandler(this.MoveNext);

         btPrev.Text = "Previous";
         btPrev.Location = new Point(10,75);
         btPrev.Click += new EventHandler(this.MovePrev);

         btSave.Text = "Save";
         btSave.Location = new Point(75,125);
         btSave.Click += new EventHandler(this.Save);

         String strConn = "Initial Catalog=TYWinforms;Data Source=localhost;User ID=sa";
         SqlConnection objConn = new SqlConnection(strConn);

         objCmd = new SqlDataAdapter("SELECT * FROM tblUsers", objConn);
         objCmd.Fill(objDS, "tblUsers");
         SqlCommandBuilder objBuilder = new SqlCommandBuilder(objCmd);

         tbFirstName.DataBindings.Add("Text", objDS, "tblUsers.FirstName");
         tbLastName.DataBindings.Add("Text", objDS, "tblUsers.LastName");

         this.Controls.Add(tbFirstName);
         this.Controls.Add(tbLastName);
         this.Controls.Add(lblFirstName);
         this.Controls.Add(lblLastName);
         this.Controls.Add(btNext);
         this.Controls.Add(btPrev);
         this.Controls.Add(btSave);
      }

      private void Save(Object Sender, EventArgs e) {
         this.BindingContext[objDS, "tblUsers"].EndCurrentEdit();

         MessageBox.Show(objCmd.Update(objDS, "tblUsers").ToString());
      }

      private void MoveNext(Object Sender, EventArgs e) {
         this.BindingContext[objDS, "tblUsers"].Position += 1;
      }

      private void MovePrev(Object Sender, EventArgs e) {
         this.BindingContext[objDS, "tblUsers"].Position -= 1;
      }

      public static void Main() {
         Application.Run(new Listing92());
      }
   }
}