using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinforms.Day10 {
   public class Exercise1 : Form {
      private MainMenu mnuMain = new MainMenu();
      private int intCounter = 0;

      public Exercise1() {
         MenuItem miQuery = mnuMain.MenuItems.Add("Query");
         MenuItem miNew = miQuery.MenuItems.Add("New");
         miNew.Click += new EventHandler(this.HandleMenu);

         MenuItem miWindow = mnuMain.MenuItems.Add("&Window");
         miWindow.MenuItems.Add("Cascade", new EventHandler(this.ArrangeWindows));
         miWindow.MenuItems.Add("Tile Horizontal", new EventHandler(this.ArrangeWindows));
         miWindow.MenuItems.Add("Tile Vertical", new EventHandler(this.ArrangeWindows));
         miWindow.MdiList = true;

         QueryDialog dlgQuery = new QueryDialog();
         this.AddOwnedForm(dlgQuery);
         dlgQuery.TopMost = true;
         dlgQuery.Show();

         this.Size = new Size(800,600);
         this.Text = "Exercise 1";
         this.Menu = mnuMain;
         this.IsMdiContainer = true;
      }

      private void ArrangeWindows(Object Sender, EventArgs e) {
         MenuItem miTemp = (MenuItem)Sender;

         switch (miTemp.Text) {
            case "Cascade":
               this.LayoutMdi(MdiLayout.Cascade);
               break;
            case "Tile Horizontal":
               this.LayoutMdi(MdiLayout.TileHorizontal);
               break;
            case "Tile Vertical":
               this.LayoutMdi(MdiLayout.TileVertical);
               break;
         }
      }

      private void HandleMenu(Object Sender, EventArgs e) {
         intCounter++;

         DataDocument doc = new DataDocument("Query Results " + intCounter.ToString());
         doc.MdiParent = this;
         doc.Show();
      }

      public static void Main() {
         Application.Run(new Exercise1());
      }
   }
}