using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinforms.Day10 {
   public class Listing102 : Form {
      private int intCounter = 0;
      private MainMenu mnuMain = new MainMenu();
      private StatusBar sbarMain = new StatusBar();

      public Listing102() {
         MenuItem miFile = mnuMain.MenuItems.Add("&File");
         miFile.MergeType = MenuMerge.MergeItems;

         MenuItem miNew = miFile.MenuItems.Add("&New");
         miNew.MergeOrder = 50;

         MenuItem miClose = miFile.MenuItems.Add("Close");
         miClose.MergeType = MenuMerge.Replace;
         miClose.MergeOrder = 100;

         MenuItem miFormat = mnuMain.MenuItems.Add("Color");
         MenuItem miColor = miFormat.MenuItems.Add("&Color...");
         miColor.Click += new EventHandler(this.ChangeColor);

         MenuItem miWindow = mnuMain.MenuItems.Add("&Window");
         miWindow.MenuItems.Add("Cascade", new EventHandler(this.ArrangeWindows));
         miWindow.MenuItems.Add("Tile Horizontal", new EventHandler(this.ArrangeWindows));
         miWindow.MenuItems.Add("Tile Vertical", new EventHandler(this.ArrangeWindows));

         miNew.Click += new EventHandler(this.HandleMenu);
         miWindow.MdiList = true;

         this.IsMdiContainer = true;
         this.Menu = mnuMain;
         this.Size = new Size(800,600);
         this.Text = "Listing 10.2";
         this.Controls.Add(sbarMain);
         this.MdiChildActivate += new EventHandler(this.UpdateStatus);
      }

      private void UpdateStatus(Object Sender, EventArgs e) {
         if (ActiveMdiChild != null) {
            sbarMain.Text = ActiveMdiChild.Text + ": " + ActiveMdiChild.BackColor.ToString();
         }
      }

      private void ChangeColor(Object Sender, EventArgs e) {
         ColorDialog dlgColor = new ColorDialog();

         if (dlgColor.ShowDialog() == DialogResult.OK) {
            if (ActiveMdiChild != null) {
               ActiveMdiChild.BackColor = dlgColor.Color;
            }
         }
      }

      private void ArrangeWindows(Object Sender, EventArgs e) {
         MenuItem miTemp = (MenuItem)Sender;

         switch (miTemp.Text) {
            case "Cascade":
               this.LayoutMdi(MdiLayout.Cascade);
               break;
            case "Tile Horizontal":
               this.LayoutMdi(MdiLayout.TileHorizontal);
               break;
            case "Tile Vertical":
               this.LayoutMdi(MdiLayout.TileVertical);
               break;
         }
      }

      private void HandleMenu(Object Sender, EventArgs e) {
         intCounter++;

         Document doc = new Document("Document " + intCounter.ToString());
         doc.MdiParent = this;
         doc.Show();
      }

      public static void Main() {
         Application.Run(new Listing102());
      }
   }
}