using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinforms.Day10 {
   public class Listing104 : Form {
      private int intCounter = 0;
      private MainMenu mnuMain = new MainMenu();

      public Listing104() {
         MenuItem miFile = mnuMain.MenuItems.Add("&File");
         MenuItem miNew = miFile.MenuItems.Add("&New");
         MenuItem miOpenIn = miFile.MenuItems.Add("Open in new Window");
         miOpenIn.Enabled = false;

         MenuItem miWindow = mnuMain.MenuItems.Add("&Window");
         miWindow.MenuItems.Add("Cascade", new EventHandler(this.ArrangeWindows));
         miWindow.MenuItems.Add("Tile Horizontal", new EventHandler(this.ArrangeWindows));
         miWindow.MenuItems.Add("Tile Vertical", new EventHandler(this.ArrangeWindows));

         miFile.Popup += new EventHandler(this.EnableOpenIn);
         miNew.Click += new EventHandler(this.HandleMenu);
         miOpenIn.Click += new EventHandler(this.OpenIn);
         miWindow.MdiList = true;

         this.IsMdiContainer = true;
         this.Menu = mnuMain;
         this.Size = new Size(800,600);
         this.Text = "Listing 10.3";
      }

      private void EnableOpenIn(Object Sender, EventArgs e) {
         if (this.ActiveMdiChild != null) {
            if (((TextBox)ActiveMdiChild.Controls[0]).SelectedText != "") {
               mnuMain.MenuItems[0].MenuItems[1].Enabled = true;
            } else {
               mnuMain.MenuItems[0].MenuItems[1].Enabled = false;
            }
         }
      }

      private void OpenIn(Object Sender, EventArgs e) {
         if (this.MdiChildren.Length > 0) {
            string strText = ((TextBox)ActiveMdiChild.Controls[0]).SelectedText;
            
            intCounter++;
            Document2 doc = new Document2("Document " + intCounter.ToString());
            doc.MdiParent = this;
            doc.Controls[0].Text = strText;
            doc.Show();
         }
      }

      private void ArrangeWindows(Object Sender, EventArgs e) {
         MenuItem miTemp = (MenuItem)Sender;

         switch (miTemp.Text) {
            case "Cascade":
               this.LayoutMdi(MdiLayout.Cascade);
               break;
            case "Tile Horizontal":
               this.LayoutMdi(MdiLayout.TileHorizontal);
               break;
            case "Tile Vertical":
               this.LayoutMdi(MdiLayout.TileVertical);
               break;
         }
      }

      private void HandleMenu(Object Sender, EventArgs e) {
         intCounter++;

         Document2 doc = new Document2("Document " + intCounter.ToString());
         doc.MdiParent = this;
         doc.Show();
      }

      public static void Main() {
         Application.Run(new Listing104());
      }
   }
}