using System;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using System.Drawing.Printing;

namespace TYWinforms.Day11 {
   public class Listing118 : Form {
      private RichTextBox rtbText = new RichTextBox();
      private MainMenu mnuMain = new MainMenu();

      public Listing118() {
         rtbText.Dock = DockStyle.Fill;
         rtbText.ScrollBars = RichTextBoxScrollBars.Both;
         rtbText.LoadFile("c:\\temp\\happy.txt", RichTextBoxStreamType.PlainText);

         MenuItem miFile = new MenuItem("File");
         MenuItem miPrint = new MenuItem("Print");
         miPrint.Click += new EventHandler(this.PrintClicked);

         mnuMain.MenuItems.Add(miFile);
         miFile.MenuItems.Add(miPrint);

         this.Menu = mnuMain;
         this.Text = "Listing 11.8";
         this.Font = new Font("Times New Roman", 10);
         this.Controls.Add(rtbText);
      }

      private void PrintClicked(Object Sender, EventArgs e) {
         PrintDocument pd = new PrintDocument();
         pd.PrintPage += new PrintPageEventHandler(this.pd_PrintPage);
         pd.Print();
      }


      private void pd_PrintPage(Object Sender, PrintPageEventArgs e) {
         StringReader objReader = new StringReader(rtbText.Text);

         Font fntPrint = this.Font;
         int count = 0; 
         float yPos = 0;
         float lpp = e.MarginBounds.Height / fntPrint.GetHeight(e.Graphics);
         float fltTopMargin = e.MarginBounds.Top;
         float fltLeftMargin = e.MarginBounds.Left;
         String strLine = null;

         while (count < lpp && ((strLine = objReader.ReadLine()) != null)) {
            yPos = fltTopMargin + (count * fntPrint.GetHeight(e.Graphics));

            e.Graphics.DrawString(strLine, fntPrint, Brushes.Black, fltLeftMargin, yPos, new StringFormat());

            count++;
         }

         if (strLine != null) {
            e.HasMorePages = true;
         } else {
            e.HasMorePages = false;
         }
      }

      public static void Main() {
         Application.Run(new Listing118());
      }
   }
}