using System;
using System.Windows.Forms;
using System.Drawing;
using System.Net;
using System.IO;

namespace TYWinforms.Day12 {
   public class Exercise1 : Form {
      private Uri URL;
      private PictureBox pbImages = new PictureBox();
      private Button btNext = new Button();
      private Image[] arrImages;
      private int intCurrentImage;
      private String strHTML;

      public Exercise1() {
         btNext.Text = "Next";
         btNext.Dock = DockStyle.Bottom;
         btNext.Click += new EventHandler(this.NextImage);

         pbImages.Dock = DockStyle.Fill;

         URL = new Uri("http://www.clpayne.com");

         CallServer();

         int intCounter = 0;
         int intIndex = strHTML.IndexOf("<img src=\"");
         while (intIndex != -1) {
            intCounter++;
            intIndex = strHTML.IndexOf("<img src=\"", intIndex+1);

            if (intIndex == -1) break;
         }       

         arrImages = new Image[intCounter];

         if (strHTML != "") {
            intCounter = 0;
            intIndex = strHTML.IndexOf("<img src=\"");
            string strTemp;

            while (intIndex != -1) {
               strTemp = strHTML.Substring(intIndex+10, strHTML.IndexOf("\"", intIndex + 11) - intIndex-10);

               arrImages[intCounter] = GetImage(strTemp);

               intIndex = strHTML.IndexOf("<img src=\"", intIndex+1);
               intCounter++;
            }
         }

         pbImages.Image = arrImages[0];
         intCurrentImage = 0;

         this.Text = "Exercise 1";
         this.Controls.Add(pbImages);
         this.Controls.Add(btNext);
      }

      private void NextImage(Object Sender, EventArgs e) {
         if (intCurrentImage == arrImages.Length - 1) {
            intCurrentImage = 0;
         } else {
            intCurrentImage++;
         }

         pbImages.Image = arrImages[intCurrentImage];
      }

      private Image GetImage(String strImageUrl) {
         Image imgTemp;

         try {
            WebRequest objRequest = WebRequest.Create("http://" + URL.Host + strImageUrl);
            WebResponse objResponse = objRequest.GetResponse();

            imgTemp = Image.FromStream(objResponse.GetResponseStream());
 
            objResponse.Close();
  
            return imgTemp;
         } catch (Exception e) {
            return null;
         }
      }

      private void CallServer() {
         WebRequest objRequest = WebRequest.Create(URL);
         WebResponse objResponse = objRequest.GetResponse();

         StreamReader objReader = new StreamReader(objResponse.GetResponseStream());

         strHTML = objReader.ReadToEnd();
 
         objReader.Close();
         objResponse.Close();
      }

      public static void Main() {
         Application.Run(new Exercise1());
      }
   }
}