using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace TYWinforms.Day13 {
   public class Listing136 : Form {
      private Point ptStartClick;
      private Point ptCurrentPos;
      private bool blnDrag = false;
      private bool blnFill = false;
      private GraphicsPath objPath;
      private PathGradientBrush objBrush;
      private Pen objPen = new Pen(Color.Black);
      private Rectangle rectSelect;

      public Listing136() {
         this.Text = "Listing 13.6";
         this.Size = new Size(800,600);
      }

      protected override void OnMouseDown(MouseEventArgs e) {
         blnDrag = true;
         ptStartClick = new Point(e.X, e.Y);
         ptCurrentPos = ptStartClick;
      }

      protected override void OnMouseUp(MouseEventArgs e) {
         blnDrag = false;
         blnFill = true;
      }

      protected override void OnMouseMove(MouseEventArgs e) {
         ptCurrentPos = new Point(e.X, e.Y);

         if (blnDrag | blnFill) {
            this.Refresh();
         }
      }
      protected override void OnPaint(PaintEventArgs e) {
         if (blnDrag) {
            objPen.DashStyle = DashStyle.Dash;

            if (ptCurrentPos.X < ptStartClick.X & ptCurrentPos.Y < ptStartClick.Y) {
               rectSelect = new Rectangle(ptCurrentPos.X, ptCurrentPos.Y, ptStartClick.X - ptCurrentPos.X, ptStartClick.Y - ptCurrentPos.Y);
            } else if (ptCurrentPos.X < ptStartClick.X & ptCurrentPos.Y > ptStartClick.Y) {
               rectSelect = new Rectangle(ptCurrentPos.X, ptStartClick.Y, ptStartClick.X - ptCurrentPos.X, ptCurrentPos.Y - ptStartClick.Y);
            } else if (ptCurrentPos.X > ptStartClick.X & ptCurrentPos.Y < ptStartClick.Y) {
               rectSelect = new Rectangle(ptStartClick.X, ptCurrentPos.Y, ptCurrentPos.X - ptStartClick.X, ptStartClick.Y - ptCurrentPos.Y);
            } else {
               rectSelect = new Rectangle(ptStartClick.X, ptStartClick.Y, ptCurrentPos.X - ptStartClick.X, ptCurrentPos.Y - ptStartClick.Y);
            }

            e.Graphics.DrawRectangle(objPen, rectSelect);
         } 

         if (blnFill && rectSelect.Width != 0 && rectSelect.Height != 0) {
            objPath = new GraphicsPath();
            objPath.AddRectangle(rectSelect);
            objBrush = new PathGradientBrush(objPath);
            objBrush.CenterColor = Color.White;
            objBrush.SurroundColors = new Color[] {Color.Red, Color.Blue, Color.Orange, Color.Green};

            e.Graphics.FillRectangle(objBrush, rectSelect);
            blnFill = false;
         }
      }

      public static void Main() {
         Application.Run(new Listing136());
      }
   }
}