using System;
using System.Windows.Forms;
using System.Drawing;
using AxSHDocVw;

namespace TYWinforms.Day14 {
   public class Exercise : Form {
      private StatusBar sbrMain = new StatusBar();
      private StatusBarPanel sbpStatus;
      private TextBox tbAddress = new TextBox();
      private Button btGo = new Button();
      private Button btStop = new Button();
      private Button btRefresh = new Button();
      private Button btHome = new Button();

      private AxSHDocVw.AxWebBrowser objBrowser = new AxSHDocVw.AxWebBrowser();
      private object arg1 = 0;
      private object arg2 = "";
      private object arg3 = "";
      private object arg4 = "";

      public Exercise() {
         sbpStatus = sbrMain.Panels.Add("");
         sbpStatus.AutoSize = StatusBarPanelAutoSize.Spring;
         sbrMain.ShowPanels = true;

         btStop.Size = new Size(55,30);
         btStop.Location = new Point(0,0);
         btStop.Text = "Stop";
         btStop.Click += new EventHandler(this.Stop);
         btStop.FlatStyle = FlatStyle.Popup;

         btRefresh.Size = new Size(55,30);
         btRefresh.Location = new Point(54,0);
         btRefresh.Text = "Refresh";
         btRefresh.Click += new EventHandler(this.Refresh);
         btRefresh.FlatStyle = FlatStyle.Popup;

         btHome.Size = new Size(55,30);
         btHome.Location = new Point(108,0);
         btHome.Text = "Home";
         btHome.Click += new EventHandler(this.GoHome);
         btHome.FlatStyle = FlatStyle.Popup;

         btGo.Size = new Size(50,20);
         btGo.Location = new Point(0,33);
         btGo.Text = "Go!";
         btGo.Click += new EventHandler(this.Go);

         tbAddress.Width = 750;
         tbAddress.Location = new Point(50,33);
         tbAddress.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;

         objBrowser.Size = new Size(800,498);
         objBrowser.Location = new Point(0,55);
         objBrowser.Anchor = AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right;

         //TitleChange occurs when the title of the Web browser changes
         objBrowser.TitleChange += new DWebBrowserEvents2_TitleChangeEventHandler(this.ChangeTitle);

         //NavigateComplete2 occurs after a web page has fully downloaded
         objBrowser.NavigateComplete2 += new DWebBrowserEvents2_NavigateComplete2EventHandler(this.UpdateAddress);

         //Occurs when the status bar of the browser updates
         objBrowser.StatusTextChange += new DWebBrowserEvents2_StatusTextChangeEventHandler(this.UpdateStatus);

         //occurs when the control has been created in the form
         objBrowser.HandleCreated += new EventHandler(this.GoHome);

         this.Text = ".NET Browser";
         this.Size = new Size(800,600);
         this.Controls.Add(objBrowser);
         this.Controls.Add(tbAddress);
         this.Controls.Add(btGo);
         this.Controls.Add(btStop);
         this.Controls.Add(btRefresh);
         this.Controls.Add(btHome);
         this.Controls.Add(sbrMain);
      }

      private void Go(Object Sender, EventArgs e) {
         //Navigate goes to the specified URL
         objBrowser.Navigate(tbAddress.Text, ref arg1, ref arg2, ref arg3, ref arg4);
      }

      private void Stop(Object Sender, EventArgs e) {
         //Stops navigation
         objBrowser.Stop();
      }

      private void Refresh(Object Sender, EventArgs e) {
         //refreshes the browser window
         objBrowser.Refresh();
      }

      private void GoHome(Object Sender, EventArgs e) {
         //goes to the default home page specified by the user
         objBrowser.GoHome();
      }

      private void ChangeTitle(Object Sender, DWebBrowserEvents2_TitleChangeEvent e) {
         this.Text = e.text;
      }

      private void UpdateAddress(Object Sender, DWebBrowserEvents2_NavigateComplete2Event e) {
         tbAddress.Text = e.uRL.ToString();
      }

      private void UpdateStatus(Object Sender, DWebBrowserEvents2_StatusTextChangeEvent e) {
         sbpStatus.Text = e.text;
      }

      public static void Main() {
         Application.Run(new Exercise());
      }
   }
}