Imports System
Imports System.Windows.Forms
Imports System.Drawing
Imports System.ServiceProcess

namespace TYWinforms.Day16 
   public class Listing163 : Inherits Form
      private objController As New ServiceController("TYWinforms Day 16 Service")

      private btStart As New Button()
      private btStop As New Button()
      private tmrService As New Timer()

      public sub New()
         objController.MachineName = "."

         btStart.Location = new Point(20,75)
         btStart.Text = "Start"
         AddHandler btStart.Click, new EventHandler(AddressOf Me.StartService)

         if objController.Status = ServiceControllerStatus.Running then
            btStart.Enabled = false
         end if

         btStop.Location = new Point(200,75)
         btStop.Text = "Stop"
         AddHandler btStop.Click, new EventHandler(AddressOf Me.StopService)

         if objController.Status = ServiceControllerStatus.Stopped then
            btStop.Enabled = false
         end if

         tmrService.Interval = 1000
         tmrService.Enabled = true
         AddHandler tmrService.Tick, new EventHandler(AddressOf Me.CheckStatus)

         Me.Text = objController.ServiceName & " " & objController.Status.ToString()
         Me.Controls.Add(btStart)
         Me.Controls.Add(btStop)
      end sub

      private sub StartService(Sender As Object, e As EventArgs) 
         objController.Start()
         btStart.Enabled = false
         btStop.Enabled = true

         ResetController()

         Me.Text = objController.ServiceName & " " & objController.Status.ToString()
      end sub

      private sub StopService(Sender As Object, e As EventArgs) 
         objController.Stop()
         btStart.Enabled = true
         btStop.Enabled = false

         ResetController()

         Me.Text = objController.ServiceName & " " & objController.Status.ToString()
      end sub

      private sub CheckStatus(Sender As Object, e As EventArgs) 
         ResetController()

         Me.Text = objController.ServiceName & " " & objController.Status.ToString()
      end sub

      private sub ResetController()
         objController = nothing
         objController = New ServiceController("TYWinforms Day 16 Service")
      end sub

      public shared sub Main() 
         Application.Run(new Listing163())
      end sub
   end class
end namespace