using System;
using System.Drawing;
using System.Windows.Forms;

namespace TYWinforms.Day18.Controls {
   public class Thermostat : Control {
      private int intTemp;
      private int intMaxTemp;

      public int Temperature {
         get { return intTemp; }
         set { 
            intTemp = value;
            Invalidate();
         }
      }

      public Thermostat() {
         intTemp = 10;
         intMaxTemp = 120;

         this.Size = new Size(50,150);
      }

      protected override void OnPaint(PaintEventArgs e) {
         e.Graphics.DrawEllipse(Pens.Black, new Rectangle(10,120,30,30));
         e.Graphics.DrawRectangle(Pens.Black, new Rectangle(15,10,20,120));

         if (intTemp <= intMaxTemp & intTemp >= 0) {
            e.Graphics.FillEllipse(Brushes.Red, new Rectangle(10,120,30,30));
            e.Graphics.FillRectangle(Brushes.Red, new Rectangle(15,120 - intTemp + 10,20,intTemp));
            e.Graphics.DrawString(intTemp.ToString() + "", new Font("Arial",15), Brushes.White, new Point(9,126));
         } else if (intTemp < 0) {
            e.Graphics.FillEllipse(Brushes.Blue, new Rectangle(10,120,30,30));
            e.Graphics.DrawString("BROKE!", new Font("Arial",10), Brushes.White, new Point(0,126));
         } else {
            e.Graphics.FillEllipse(Brushes.Red, new Rectangle(10,120,30,30));
            e.Graphics.FillRectangle(Brushes.Red, new Rectangle(15,10,20,120));
            e.Graphics.DrawString("BROKE!", new Font("Arial",10), Brushes.White, new Point(0,126));
         }
      }
   }
}