using System;
using System.Drawing;
using System.Windows.Forms;
using System.Threading;
using System.IO;

namespace TYWinforms.Day19 {
   public class Exercise : Form {
      private ListBox lbxResults = new ListBox();
      private TextBox tbSearch = new TextBox();
      private Button btSearch = new Button();
      private Label lblStatus = new Label();

      private bool blnSearching;
      private Thread thdSearch;

      public Exercise() {
         blnSearching = false;

         btSearch.Location = new Point(125,10);
         btSearch.Text = "Search!";
         btSearch.Click += new EventHandler(this.BeginSearch);

         tbSearch.Location = new Point(10,10);
         lblStatus.Location = new Point(10,50);

         lbxResults.Location = new Point(250,10);
         lbxResults.Size = new Size(525,590);

         this.Size = new Size(800,600);
         this.Text = "Exercise";
         this.Controls.Add(lbxResults);
         this.Controls.Add(tbSearch);
         this.Controls.Add(btSearch);
         this.Controls.Add(lblStatus);
      }

      public void BeginSearch(Object Sender, EventArgs e) {
         if (blnSearching) { return; }
 
         lblStatus.Text = "Searching...";

         thdSearch = new Thread(new ThreadStart(ThreadSearch));
         blnSearching = true;
         btSearch.Enabled = false;
         thdSearch.Start();
      }

      private void RecurseDirectory(string strSearchPath) {
         string strDirectory = Path.GetDirectoryName(strSearchPath);
         string strSearch = Path.GetFileName(strSearchPath);

         if (strDirectory == null || strSearch == null) {
            return;
         }

         string[] arrFiles;

         try {
            arrFiles = Directory.GetFiles(strDirectory, strSearch);
         } catch (Exception e) {
            return;
         }

         for (int i = 0; i < arrFiles.Length; i++) {
            lbxResults.Items.Add(arrFiles[i]);
         }

         string[] arrDirectories = Directory.GetDirectories(strDirectory);
         foreach(string d in arrDirectories) {
            RecurseDirectory(Path.Combine(d, strSearch));
         }
      }

      private void ThreadSearch() {
         string strSearch = tbSearch.Text;
         if (Path.GetPathRoot(strSearch) == "") {
            strSearch = "c:\\" + strSearch;
         }

         RecurseDirectory(strSearch);

         blnSearching = false;
         btSearch.Enabled = true;
         lblStatus.Text = "Done";
      }

      private static void Main() {
         Application.Run(new Exercise());
      }
   }
}