using System;
using System.Windows.Forms;
using System.Drawing;
using System.Diagnostics;

namespace TYWinforms.Day21 {
   public class Listing212 : Form {
      private Label lblProcessor = new Label();
      private Label lblMemory = new Label();
      private Label lblTotProcessor = new Label();
      private Process objProcess = new Process();
      private System.Windows.Forms.Timer tmrProcess = new System.Windows.Forms.Timer();

      public Listing212() {
         lblProcessor.Size = new Size(250,20);
         lblProcessor.Location = new Point(10,10);

         lblMemory.Size = new Size(250,20);
         lblMemory.Location = new Point(10,30);

         lblTotProcessor.Size = new Size(250,20);
         lblTotProcessor.Location = new Point(10,50);

         tmrProcess.Tick += new EventHandler(this.Update);
         tmrProcess.Interval = 500;
         tmrProcess.Start();

         objProcess = Process.GetCurrentProcess();

         this.Text = ".NET Profiler";
         this.Controls.Add(lblProcessor);
         this.Controls.Add(lblMemory);
         this.Controls.Add(lblTotProcessor);
      }

      private void Update(Object Sender, EventArgs e) {
         objProcess.Refresh();
         lblMemory.Text = "Memory: " + objProcess.PrivateMemorySize.ToString();
         lblProcessor.Text = "Private Processor Time: " + objProcess.PrivilegedProcessorTime.ToString();
         lblTotProcessor.Text = "Total Processor Time: " + objProcess.TotalProcessorTime.ToString();
      }

      public static void Main() {
         Application.Run(new Listing212());
      }
   }
}