Imports System
Imports System.Windows.Forms
Imports System.Drawing

namespace TYWinforms.P1 
   public class FindDialog : Inherits Form 
      private lblFind as New Label()
      private lblReplace as New Label()
      private tbFind as New TextBox()
      private tbReplace as New TextBox()
      private btFind as New Button()
      private btReplace as New Button()
      private btReplaceAll as New Button()
      private btCancel as New Button()

      private rtbDoc as RichTextBox

      public sub New(rtbParentDoc as RichTextBox)
         rtbDoc = rtbParentDoc

         lblFind.Text = "Find:"
         lblFind.Location = New Point(10,10)
         lblFind.Width = 50

         lblReplace.Text = "Replace:"
         lblReplace.Location = New Point(10,35)
         lblReplace.Width = 50

         tbFind.Width = 100
         tbFind.Location = New Point(60,10)

         tbReplace.Width = 100
         tbReplace.Location = New Point(60,35)

         btFind.Size = New Size(75,25)
         btFind.Text = "Find"
         btFind.Location = New Point(170,10)
         AddHandler btFind.Click, new EventHandler(AddressOf Me.ButtonClicked)

         btReplace.Size = New Size(75,25)
         btReplace.Text = "Replace"
         btReplace.Location = New Point(170,35)
         AddHandler btReplace.Click, new EventHandler(AddressOf Me.ButtonClicked)

         btReplaceAll.Size = New Size(75,25)
         btReplaceAll.Text = "Replace All"
         btReplaceAll.Location = New Point(170,60)
         AddHandler btReplaceAll.Click, new EventHandler(AddressOf Me.ButtonClicked)

         btCancel.Size = New Size(75,25)
         btCancel.Text = "Cancel"
         btCancel.Location = New Point(170,85)
         AddHandler btCancel.Click, new EventHandler(AddressOf Me.ButtonClicked)

         Me.Text = "Find"
         Me.Size = New Size(255,140)
         Me.MaximizeBox = false
         Me.MinimizeBox = false
         Me.FormBorderStyle = FormBorderStyle.FixedDialog
         Me.TopMost = true

         Me.Controls.Add(lblFind)
         Me.Controls.Add(lblReplace)
         Me.Controls.Add(tbFind)
         Me.Controls.Add(tbReplace)
         Me.Controls.Add(btFind)
         Me.Controls.Add(btReplace)
         Me.Controls.Add(btReplaceAll)
         Me.Controls.Add(btCancel)
      end sub

      private sub ButtonClicked(Sender as Object, e as EventArgs) 
         dim btTemp as Button = CType(Sender, Button)
         dim intLocation as Integer
         dim intCount as Integer = 0

         select case btTemp.Text
            case "Find"
               intLocation = rtbDoc.Find(tbFind.Text, rtbDoc.SelectionStart + rtbDoc.SelectionLength, RichTextBoxFinds.None)
               if intLocation <> -1
                  rtbDoc.SelectionStart = intLocation
                  rtbDoc.SelectionLength = tbFind.Text.Length
                  rtbDoc.Focus()
               end if
            case "Replace"
               intLocation = rtbDoc.Find(tbFind.Text, rtbDoc.SelectionStart + rtbDoc.SelectionLength, RichTextBoxFinds.None)
               if intLocation <> -1
                  rtbDoc.SelectionStart = intLocation
                  rtbDoc.SelectionLength = tbFind.Text.Length
                  rtbDoc.SelectedText = tbReplace.Text
                  rtbDoc.SelectionStart = intLocation
                  rtbDoc.SelectionLength = tbReplace.Text.Length
               end if
            case "Replace All"
               intLocation = rtbDoc.Find(tbFind.Text)
               while intLocation <> -1
                  rtbDoc.SelectionStart = intLocation
                  rtbDoc.SelectionLength = tbFind.Text.Length
                  rtbDoc.SelectedText = tbReplace.Text
                  intCount += 1
                  intLocation = rtbDoc.Find(tbFind.Text, rtbDoc.SelectionStart + rtbDoc.SelectionLength, RichTextBoxFinds.None)
               end while
               MessageBox.Show(intCount.ToString() + " occurrences replaced","Find")
            case "Cancel"
               Me.Close()
         end select
      end sub
   end class
end namespace